# Copyright 2010 Mihai Bocsaru, PRO IT Service
# info@pro-it-service.com. All rights reserved.
# This code is released under Creative Commons
# Attribution-Share Alike 3.0 license
# http://creativecommons.org/licenses/by-sa/3.0/

package MT::Plugin::BlankTarget;

use strict;
use MT;

use vars qw( $VERSION );
$VERSION = '0.1';

my $plugin;
eval {
    require MT::Plugin;
    $plugin = MT::Plugin->new({
        name => 'MT-BlankTarget',
        description => "<MT_TRANS phrase=\"Provides the ability to open links in new windows.\">",
        author_name => 'Mihai Bocsaru',
        author_link => 'http://www.pro-it-service.com/',
        version => $VERSION,
    });
    MT->add_plugin($plugin);
};

use MT::Template::Context;
MT::Template::Context->add_global_filter('blank_target' => \&blank_target);

sub blank_target {
    my ($str, $arg, $ctx) = @_;
    return $str unless ($arg);
    $str =~ s#<\s*a\s([^>]*\s*href\s*=[^>]*)>#
        my @attr = $1 =~ /[^=\s]*\s*=\s*"[^"]*"|[^=\s]*\s*=\s*'[^']*'|[^=\s]*\s*=[^\s]*/g;
        my @target = grep { /^target\s*=/i } @attr;
        my $target;
        $target = pop @target if (@target);
        if ($target) {
            $target =~ s/^(target\s*=\s*['"]?)/$1/i;
        } else {
            $target = 'target="_blank"';
        }
        @attr = grep { !/^target\s*=/i } @attr;
        '<a ' . (join ' ', @attr) . ' ' . $target . '>';
    #xieg;
    $str;
}

1;